﻿var ERROR = 'error';
var SUCCESS = 'success';

var ERROR_NOT_TEXT = 'error not text';
var ERROR_NO_LAYER_SELECTED = 'error no layer selected';
var ERROR_LAYER_LOCKED = 'error layer locked';

function hasOpenDocument() {
  if (app.documents.length > 0) {
    return 1;
  }
  else {
    return 0;
  }
}

function getActiveLayers() {
  var activeLayer = getActiveLayer();
  if (activeLayer === false) {
    return JSONify(ERROR, ERROR_NO_LAYER_SELECTED);
  }
  else if (activeLayer.allLocked === true) {
    return JSONify(ERROR, ERROR_LAYER_LOCKED);
  }
  else if (activeLayer.typename !== 'ArtLayer') {
    return JSONify(ERROR, ERROR_NOT_TEXT);
  }
  else if (activeLayer.kind != LayerKind.TEXT) {
    return JSONify(ERROR, ERROR_NOT_TEXT);
  }
  else {
    activeLayer = ArtLayer(activeLayer);
    var textContent = String(app.activeDocument.activeLayer.textItem.contents);
    return JSONify(SUCCESS, textContent);
  }
}

function addTranslatedTextLayer(toLanguage,translatedString) {
  var activeLayer = getActiveLayer();
  if (activeLayer !== false) {
    if (activeLayer.typename === 'ArtLayer' && activeLayer.kind == LayerKind.TEXT) {
      var duplicatedLayer = activeLayer.duplicate();
      duplicatedLayer.textItem.contents = translatedString;
      duplicatedLayer.name = '[' + toLanguage.toUpperCase() + '] ' + activeLayer.name;
      activeLayer.visible = false;
      return JSONify(SUCCESS, 'success');
    }
    else {
      return JSONify(ERROR, ERROR_NOT_TEXT);
    }
  }
  else {
    return JSONify(ERROR, ERROR_NO_LAYER_SELECTED);
  }
}

function getActiveLayer() {
  if (app.documents.length > 0 && 
    (app.activeDocument.activeLayer !== null || 
       app.activeDocument.activeLayer !== undefined)) {
    return app.activeDocument.activeLayer;
  }
  else {
    return false;
  }
}

function JSONify(type, message) {
  return '{"' + type + '":"' + message + '"}';
}